EC2N Class Reference

Elliptic Curve over GF(2^n) More...

Inheritance diagram for EC2N:

## Public Types

typedef GF2NP | Field
typedef Field::Element | FieldElement
typedef EC2NPoint | Point
Public Types inherited from AbstractGroup< EC2NPoint >
typedef EC2NPoint | Element

## Public Member Functions

| EC2N (const Field &field, const Field::Element &a, const Field::Element &b)
| EC2N (BufferedTransformation &bt)
void | DEREncode (BufferedTransformation &bt) const
bool | Equal (const Point &P, const Point &Q) const
| Compare two elements for equality. More...
const Point & | Identity () const
const Point & | Inverse (const Point &P) const
| Inverts the element in the group. More...
bool | InversionIsFast () const
const Point & | Add (const Point &P, const Point &Q) const
| Adds elements in the group. More...
const Point & | Double (const Point &P) const
| Doubles an element in the group. More...
Point | Multiply (const Integer &k, const Point &P) const
Point | CascadeMultiply (const Integer &k1, const Point &P, const Integer &k2, const Point &Q) const
bool | ValidateParameters (RandomNumberGenerator &rng, unsigned int level=3) const
bool | VerifyPoint (const Point &P) const
unsigned int | EncodedPointSize (bool compressed=false) const
bool | DecodePoint (Point &P, BufferedTransformation &bt, size_t len) const
bool | DecodePoint (Point &P, const byte *encodedPoint, size_t len) const
void | EncodePoint (byte *encodedPoint, const Point &P, bool compressed) const
void | EncodePoint (BufferedTransformation &bt, const Point &P, bool compressed) const
Point | BERDecodePoint (BufferedTransformation &bt) const
void | DEREncodePoint (BufferedTransformation &bt, const Point &P, bool compressed) const
Integer | FieldSize () const
const Field & | GetField () const
const FieldElement & | GetA () const
const FieldElement & | GetB () const
bool | operator== (const EC2N &rhs) const
Public Member Functions inherited from AbstractGroup< EC2NPoint >
virtual const Element & | Identity () const=0
| Provides the Identity element. More...
virtual bool | InversionIsFast () const
| Determine if inversion is fast. More...
virtual const Element & | Subtract (const Element &a, const Element &b) const
| Subtracts elements in the group. More...
virtual Element & | Accumulate (Element &a, const Element &b) const
| TODO. More...
virtual Element & | Reduce (Element &a, const Element &b) const
| Reduces an element in the congruence class. More...
virtual Element | ScalarMultiply (const Element &a, const Integer &e) const
| Performs a scalar multiplication. More...
virtual Element | CascadeScalarMultiply (const Element &x, const Integer &e1, const Element &y, const Integer &e2) const
| TODO. More...
virtual void | SimultaneousMultiply (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const
| Multiplies a base to multiple exponents in a group. More...

## Detailed Description

Elliptic Curve over GF(2^n)

Definition at line 44 of file ec2n.h.

## Member Function Documentation

## Equal()

bool EC2N::Equal | ( | const Point & | a,
|  | const Point & | b
| ) |  | const

virtual

Compare two elements for equality.

Parameters

  a | first element
  b | second element

Returns
  true if the elements are equal, false otherwise

Equal() tests the elements for equality using `a==b`

Implements AbstractGroup< EC2NPoint >.

Definition at line 164 of file ec2n.cpp.

## Inverse()

const EC2N::Point & EC2N::Inverse | ( | const Point & | a | ) | const

virtual

Inverts the element in the group.

Parameters

  a | first element

Returns
  the inverse of the element

Implements AbstractGroup< EC2NPoint >.

Definition at line 183 of file ec2n.cpp.

## Add()

const EC2N::Point & EC2N::Add | ( | const Point & | a,
|  | const Point & | b
| ) |  | const

virtual

Adds elements in the group.

Parameters

  a | first element
  b | second element

Returns
  the sum of `a` and `b`

Implements AbstractGroup< EC2NPoint >.

Definition at line 196 of file ec2n.cpp.

## Double()

const EC2N::Point & EC2N::Double | ( | const Point & | a | ) | const

virtual

Doubles an element in the group.

Parameters

  a | the element

Returns
  the element doubled

Reimplemented from AbstractGroup< EC2NPoint >.

Definition at line 218 of file ec2n.cpp.

The documentation for this class was generated from the following files:

- ec2n.h
- ec2n.cpp